      subroutine kapbar(xmass,aion,zion,ionmax, &
                        xh,xhe,xz,w4,w5,w6,zalf)
      include 'implno.dek'

! this routine calculates composition variables for an opacity routine

! input:
! mass fractions     = xmass(1:ionmax)
! number of nucleons = aion(1:ionmax)
! charge of nucleus  = zion(1:ionmax)
! number of isotopes = ionmax
!
! output:
! mass fraction of hydrogen = xh
! mass fraction of helium   = xhe
! mass fraction of metals   = xz
! charge squared weighted mass fraction of hydrogen = w4
! charge squared weighted mass fraction of helium   = w5
! charge squared weighted mass fraction of metals   = w6
! average charge squared aion**(2/3)                = zalf
!

      integer           :: ionmax,i,iz
      real*8            :: xmass(ionmax),aion(ionmax),zion(ionmax), &
                           xh,xhe,xz,w4,w5,w6,zalf, &
                           w(6),ztemp
      real*8, parameter :: twoth = 2.0d0/3.0d0

      zalf = 0.0d0
       w(1:6) = 0.0d0
      do i = 1,ionmax
       iz      = min(3,max(1,int(zion(i))))
       ztemp   = zion(i) * zion(i) * xmass(i)/aion(i)
       w(iz)   = w(iz)   + xmass(i)
       w(iz+3) = w(iz+3) + ztemp
       zalf    = zalf  + ztemp * aion(i)**twoth
      enddo
      xh   = w(1)
      xhe  = w(2)
      xz   = w(3)
      w4   = w(4)
      w5   = w(5)
      w6   = w(6)
      return
      end subroutine kapbar
